//+------------------------------------------------------------------+
//|                                                      MgrWrkr.mq4 |
//|                                                      nicholishen |
//|                         https://www.forexfactory.com/nicholishen |
//+------------------------------------------------------------------+
#property strict
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+

#include "mgr.mqh"

void OnStart()
{
//---
   Manager mgr(_Symbol, _Period);
   
   for(int i=0; i<5; i++)
      mgr.add_worker(i);
      
   Worker *zero = mgr.workers()[0]; //getting a worker from manager
   //Worker *one = zero.colleagues()[0];//access to colleagues directly from worker via manager proxy
   
   printf("I am worker %d and I have %d colleagues.", 
      zero.id(), zero.colleagues().Total()
   );
   printf("I am a colleague of worker %d and my id is %d",
      zero.id(), zero.colleagues()[0].id()
   );
   printf("assert workers access to manager via colleagues");
   printf("%s == %s",
      zero.symbol(), zero.colleagues()[0].symbol()
   );
   printf("Manager state change to USDJPY");
   
   mgr.symbol("USDJPY");
   
   printf("%s == %s",
      zero.symbol(), zero.colleagues()[0].symbol()
   );
}
//+------------------------------------------------------------------+
