
#include "worker.mqh"


class Manager {
   string               m_symbol;
   int                  m_timeframe;
   objvector<Worker*>   m_workers;
public:
                        Manager(string s, int tf):m_symbol(s),
                                                  m_timeframe(tf){}
   void                 add_worker(int id);
   string               symbol()    const { return m_symbol; }
   void                 symbol(string s)  { m_symbol = s; }
   int                  timeframe() const { return m_timeframe; }
   objvector<Worker*>*  workers() { return &m_workers; }
};

void Manager::add_worker(int id)
{
   Worker *worker = new Worker(&this, id);
   m_workers.Add(worker);
}